/***********************************************************************
 *      This example program is an excerpt from the book:              *
 *                                                                     *
 *          X Window OSF/Motif Toolkit Programming (I)                 *
 *            - Programming Basics, Resource and Event -               *
 *                                                                     *
 *      Copyright 1994, Hideyuki Hayashi                               *
 *                                                                     *
 *      This program can be distributed without fee, provided          *
 *      that the above copyright notice appear in all copies.          *
 ***********************************************************************/

#include <Xm/XmAll.h>

/* Callback function called when user input on the drawing area */
static void DrawCB(w, client_data, call_data)
    Widget    w;
    XtPointer client_data;
    XtPointer call_data;
{
    XmDrawingAreaCallbackStruct *cb = (XmDrawingAreaCallbackStruct *)call_data;
    int x, y;

    /* cb->event is Event Struct                    */
    /*         cb->event->type is Event Type      */
    /*                    Button is pressed     */
    /*                                        */
    if (cb->event->type == ButtonPress) {
        x = cb->event->xbutton.x;  /* X coordinate */
        y = cb->event->xbutton.y;  /* Y coordinate */
        printf("Pressed position: (%d,%d)\n", x, y);
    }
}

main(argc, argv)
    int  argc;
    char **argv;
{
    XtAppContext app_context;
    Widget  toplevel, bboard, canvas;
    Arg     al[20];
    int     ac;


    XtSetLanguageProc(NULL, NULL, NULL);

    ac = 0;
    toplevel = XtAppInitialize(&app_context, "Callbackevnt", NULL, 0,
                               &argc, argv, NULL, al, ac);

    ac = 0;
    bboard = XmCreateBulletinBoard(toplevel, "bboard", al, ac);
    XtManageChild(bboard);

    ac = 0;
    XtSetArg(al[ac], XmNwidth, 200); ac++;
    XtSetArg(al[ac], XmNheight, 200); ac++;
    canvas = XmCreateDrawingArea(bboard, "canvas", al, ac);
    XtManageChild(canvas);

    /* Register a callback called when user input on the drawing area */
    XtAddCallback(canvas, XmNinputCallback, DrawCB, NULL);

    XtRealizeWidget(toplevel);
    XtAppMainLoop(app_context);
}
