/***********************************************************************
 *      This example program is an excerpt from the book:              *
 *                                                                     *
 *          X Window OSF/Motif Toolkit Programming (I)                 *
 *            - Programming Basics, Resource and Event -               *
 *                                                                     *
 *      Copyright 1994, Hideyuki Hayashi                               *
 *                                                                     *
 *      This program can be distributed without fee, provided          *
 *      that the above copyright notice appear in all copies.          *
 ***********************************************************************/

#include <Xm/XmAll.h>

main(argc, argv)
    int  argc;
    char **argv;
{
    XtAppContext app_context;
    Widget toplevel, rowcol, toggle, text, button;
    Arg    al[20];
    int    ac;

    static char *value;
    XmString cstring;

    XtSetLanguageProc(NULL, NULL, NULL);

    ac = 0;
    XtSetArg(al[ac], XmNmaxWidth, 400); ac++;
    XtSetArg(al[ac], XmNmaxHeight, 200); ac++;
    toplevel = XtAppInitialize(&app_context, "Resfree", NULL, 0,
                               &argc, argv, NULL, al, ac);

    ac = 0;
    XtSetArg(al[ac], XmNmarginWidth, 20); ac++;
    XtSetArg(al[ac], XmNmarginHeight, 10); ac++;
    rowcol = XmCreateRowColumn(toplevel, "rowcol", al, ac);
    XtManageChild(rowcol);

    ac = 0;
    XtSetArg(al[ac], XmNset, True); ac++;
    toggle = XmCreateToggleButton(rowcol, "toggle", al, ac);
    XtManageChild(toggle);

    /* Allocate the space and copy the text */
    value = XtMalloc(1024);
    strcpy(value, "Allocated Text");

    /* Create a label on push button (Compound String) */
    cstring = XmStringCreateLocalized("Push this Button");

    ac = 0;
    XtSetArg(al[ac], XmNvalue, value); ac++; /* Set the text */
    text = XmCreateTextField(rowcol, "text", al, ac);
    XtManageChild(text);

    ac = 0;
    XtSetArg(al[ac], XmNlabelString, cstring); ac++; /* Set the label string */
    button = XmCreatePushButton(rowcol, "button", al, ac);
    XtManageChild(button);

    XtFree(value); /* This value is not necessary any more */
    XmStringFree(cstring); /* This compound string is not necessary any more */

    XtRealizeWidget(toplevel);
    XtAppMainLoop(app_context);
}
